import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class Percolation extends Frame
{  public int ID1, ID2;public double ER;
   public double LeftP, TopP, sX, sY;
   public double currentX, currentY; // ݂̕`ʒu
   public Percolation()
   {  setSize(1100,700);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   private void setCell(byte[][] A, int N, int M)
   {  int X, Y;
      do
      { X = (int)((double)N * Math.random() + 1); 
        Y = (int)((double)M * Math.random() + 1);
      } while( A[X][Y] != 0);
      A[X][Y] = 1;
   }
   public byte[][] InitCells(int N, int M)
   {  byte [][] A= new byte[N+1][M+1];
      for(int i = 0; i <= N; i++)for(int j = 0; j <= N; j++) A[i][j]=0;
      return A;
   }
   private int direction(int [][] Hist,byte[][]A,byte[][]D, int i, int j, int IP, int N, int M)
   { int ID;
     int IIP = IP; if(IIP > N * M) IIP--;
     Hist[IP][0] = j; Hist[IP][1] = i;
     if( j > M)                              return IIP;
     else if( (j < 1) || (i < 1) || (i > M)) return -1;
     else if(D[i][j] != 0)                   return -1;
     else
     {  D[i][j] = 1;
        if(A[i][j] == 0) return -1;
        else
        {  ID = direction(Hist,A, D, i, j + 1, IIP + 1, N, M);
           if(ID>=0) return ID;
           ID = direction(Hist,A, D, i, j - 1, IIP + 1, N, M);
           if(ID>=0) return ID;
           ID = direction(Hist,A, D, i + 1, j, IIP + 1, N, M);
           if(ID>=0) return ID;
           return direction(Hist,A, D, i - 1, j, IIP + 1, N, M);
         }
     }
   }
   private int Judge(int[][]Hist, byte [][]A,int N, int M)
   {  byte [][] D = new byte[N+1][M+1];
      int ID;
      for(int i = 0; i <= N; i++)for(int j = 0; j <= M; j++) D[i][j] = 0;
      for(int i = 1; i <= N; i++)
      {  if(A[i][1] != 0)
         {  ID = direction(Hist,A, D, i, 1, 0, N, M);
            if(ID>=0) return ID;
         }
       }
       return -1;
   }
   private int perco(int [][]Hist, byte[][]A, int N, int M)
   { long i;
     long MM = ((long) M) * ((long)N);
     for(i = 1; i<=MM; i++)
     {   setCell(A, N,M);int ID=Judge(Hist, A, N, M); if(ID>=0) return ID;
     }
     return 0;
   }
   public void drawInit(double X1, double Y1, double SX, double SY)
   {  LeftP = X1; TopP = Y1; sX = SX; sY = SY;
   }
   public int Xpos(double X)
   {  return (int)(LeftP + X * sX);}
   public int Ypos(double Y)
   {  return (int)(TopP  + Y * sY);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.fillOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawCircle(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawRect(Graphics g, double X, double Y)
   {  g.drawRect(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      return Math.rint(D*DN)/DN;
   }
   
   public void paint(Graphics g)
   { setTitle("̓dC`");
     int N=100;int M=100;
     byte[][]A = InitCells(N, M);
     int [][]Hist=new int[N * M][2]; 
     int IHP = perco(Hist, A, N, M);
     drawInit(100, 100, 2, 2);
     for(int i = 1; i <= N; i++)  for(int j = 1; j <= N; j++)
     {  if(A[i][j]==0) g.setColor(new Color(  0,0,255));
        else           g.setColor(new Color(255,255,0));
        g.fillRect(Xpos(j),Ypos(i),2,2);
     }
     if(IHP>0)
     {  g.setColor(new Color(255,0,0));
        for(int i = 0; i <= IHP; i++)
           g.fillRect(Xpos(Hist[i][0]),Ypos(Hist[i][1]),2,2);
     }
   }
   public static void main(String[] args)
   {  Frame w = new Percolation();
      w.setVisible(true);
   }
}
